%camera calibration code

% KK_hmgen = zeros(3,4);
% M = zeros(4,4);
% 
% KK = [468.7294,0,159.5000,0;0, 477.4816,  119.5000,0;0, 0,1.0000,0];
% M = [ -0.0216    0.9992   -0.0329 -108.6637;
%     0.5869   -0.0140   -0.8095   -95.6968;
%    -0.8094   -0.0368   -0.5861    630.53;
%    0 0 0 1];
% 
% 
% M2 = KK*M;

% KK = zeros(3,3);
% Rc_1 = zeros(3,3);
% Tc_1 = zeros(3,1);
% P = zeros(3,4);
% calib_gui;

data_calib;
click_calib;
go_calib_optim;

Rc_1
Tc_1
% 
% KK  =  [468.6444         0  159.5000
%          0  477.2298  119.5000
%          0         0    1.0000];
%      
% Rc_1 =[-0.0216    0.9992   -0.0330
%     0.5871   -0.0140   -0.8094
%    -0.8092   -0.0368   -0.5863];
% 
% Tc_1 =[-93.1401
%   -82.0542
%   540.3609];

KK1 = zeros(3,4);
R = zeros(4,4);
P = zeros(3,4);
for i = 1:3
    for j = 1:3
        KK1(i,j) = KK(i,j);
        R(i,j) = Rc_1(i,j);
    end
end

for i = 1:3
    R(i,4) = Tc_1(i);
end

R(4,4) = 1;

P = KK1*R;

imshow('Picture_1.jpg');
image_pt = zeros(3,1);
[image_pt(1,1),image_pt(2,1)] = ginput(1);

image_pt(1,1)
image_pt(2,1)

% 
%   image_pt(1,1) = 103; % x cood
%   image_pt(2,1) = 60; % y cood
image_pt(3,1) = 1;

world_point = zeros(3,1);

A = zeros(2,2);
B = zeros(2,1);

A(1,1) = image_pt(1,1)*P(3,1) - P(1,1);
A(1,2) = image_pt(1,1)*P(3,2) - P(1,2);
A(2,1) = image_pt(2,1)*P(3,1) - P(2,1);
A(2,2) = image_pt(2,1)*P(3,2) - P(2,2);

B(1,1) = P(1,4) - image_pt(1,1)*P(3,4);
B(2,1) = P(2,4) - image_pt(2,1)*P(3,4);



X_pt = A\B;

disp ('The co-ordinates of the point in cms are');

X_pt(1,1)/10
X_pt(2,1)/10

%sprintf('The co-ordinates of the point in cms are, x cood - %f and y cood - %f', X_pt(1,1)/10, X_pt(2,1)/10);


%imtool('Image1.tif');




% world_point = inv(Rc_1)*(inv(KK)*image_pt-Tc_1);

